function [H,Q,fit,myss,err] = numfit(den,s,n,f)
% den: denominator, s=jw, n: num degree, f: data
m = length(s);
Q = [real(den);imag(den)]*sqrt(m)/norm(den);
H = zeros(n+1,n);
for k = 1:n %Lanczos for skew-symmetric matrix
    q1 = Q(1:m,k);
    q2 = Q(m+1:2*m,k);
    q = [-imag(s).*q2; imag(s).*q1];
    if k>1 
        H(k-1,k) = -H(k,k-1);
        q = q - H(k-1,k)*Q(:,k-1); 
    end        
    H(k+1,k) = norm(q)/sqrt(m);
    Q = [Q q/H(k+1,k)];
end
% cond(Q)
if nargin == 4 %data is provided
    g = Q\[real(f); imag(f)]; %coeffs of numerator
    fit = Q*g;
    fit = fit(1:end/2,:)+ 1i*fit(end/2+1:end,:);
    err = norm(fit(:)-f(:));
    c = Q\[ones(m,1); zeros(m,1)]; %coeffs of denominator
    e=zeros(n,1);
    e(n)=1;
    g=g';
    A=H(1:n,1:n)'-H(n+1,n)*e*c(1:n)'/c(n+1);
    B=H(n+1,n)*e/c(n+1);
    C=g(:,1:end-1)-g(:,end)*c(1:n)'/c(n+1);
    D=g(:,end)/c(n+1);
    myss=ss(A,B,C,D); %state-space assuming improper rational function    
end


