function [poles,fit,myss,err] = ora(file,ind,n,d,iter) 
% file: touchstone filename, ind: index of matrix elements
% n,d: degree of num and den, iter: iteration count
% example: ora('filename.s2p',[1 1;1 2;2 1;2 2],50,50,20);
S = sparameters(file);
f = [];
for k = 1:size(ind,1)
    f = [f squeeze(S.Parameters(ind(k,1),ind(k,2),:))];
end
frequency = S.Frequencies;
denk = ones(length(frequency),1); %initial denominator is a 1 vector
s=1i*2*pi*frequency;
err = inf;
for k = 1:iter %SK iteration
    [denk,polesk] = denfit(denk,s,n,d,f);
    [~,~,fitk,myssk,errk] = numfit(denk,s,n,f);
    if errk<err %keep the best fit in iterations
        poles=polesk;
        fit=fitk;
        myss=myssk;
        err=errk;
    end
end
if n~=d %state-space implemented only for improper rational functions
    myss=[];
end


